import josx.platform.rcx.*;
import tinyvm.rcx.Timer;



public class Start{

    //zurckgelegte Wegstrecke der Rder
    public static int s1=0;
    public static int s3=0;
    //interne Uhr
    public static int time=0;
    //Variable zum deaktivieren des SensorListeners
    public static boolean ignoreSensorListener=false;
    //Variable die beschreibt, ob der Timer gerade aktiv oder inaktiv ist
    public static boolean activeTimer=true;
    //gibt an, ob das LCD zum schreiben frei ist oder ob es gerade ein andere Ausgabe sperrt
    public static boolean LCDfree=true;
    //Kantenzhler
    public static int edges=0;
    //aktueller Status der Operation
    public static int status=explore;
    public static final int explore=0;
    public static final int turnAround=1;
    public static final int bringBack=2;
    //Hilfsvariable, die beim Korrigieren eine Unterscheidung von links und rechts zult
    public static int correct=0;
    //Startwert fr den TimerListener2-Wert, der auch mit dem ButtonListener eingestellt werden kann
    public static int ariane=20;
    
    //Interne Uhr
    public static Timer MyTimer1= new Timer(10,new MyTimerListener1());
    //Timer, der nach einer gewissen Zeit ohne Statusvernderungen anschlgt
    public static Timer MyTimer2= new Timer(10,new MyTimerListener2());
    //Timer, der eine gewisse Zeit wartet und danach ignoreSensorListener auf "false" setzt
    public static Timer MyTimer3= new Timer(100,new MyTimerListener3());
    //Korrekturtimer nach dem rumschieben
    public static Timer MyTimer4= new Timer(10,new MyTimerListener4());

    //beschreibt letzten Zustand des Roboters
    public static int lastStatement=3;
    public static final int leftTouch=0;
    public static final int leftnoTouch=1;
    public static final int rightTouch=2;
    public static final int rightnoTouch=3;
    public static final int leftandrightTouch=4;
    public static final int leftandrightnoTouch=5;
    //Hilfsvariable fr TimerListener4
    public static int cnt=0;

    //Main-Methode initialisiert alle Sensor-Listener und TimerLister, etc. und geht dann in eine Endlosschleife
    public static void main (String[] aArg){
	
	Sensor.S1.setTypeAndMode (SensorConstants.SENSOR_TYPE_TOUCH,SensorConstants.SENSOR_MODE_BOOL);
     	Sensor.S1.activate();
        Sensor.S2.setTypeAndMode (SensorConstants.SENSOR_TYPE_TOUCH,SensorConstants.SENSOR_MODE_BOOL);
     	Sensor.S2.activate();
	Sensor.S3.setTypeAndMode (SensorConstants.SENSOR_TYPE_TOUCH,SensorConstants.SENSOR_MODE_BOOL);
     	Sensor.S3.activate();
	Motor.A.setPower(7);
	Motor.C.setPower(7);
	Motor.A.forward();
	Motor.C.forward();


	Sensor.S1.addSensorListener(new MySensorListener());
	Sensor.S3.addSensorListener(new MySensorListener());
        Sensor.S2.addSensorListener(new MySensorListener());
	Button.RUN.addButtonListener(new MyButtonListener());

       Serial.addSerialListener(new MySerialListener());

	MyTimer1.start();
	MyTimer2.start();
        
        while(true);
    }
    
    //Rechtskurve
    public static void rightBend(){

	Motor.A.stop();
	}

    //Linkskurve
    public static void leftBend(){

	Motor.C.stop();
	}

    //zurcksetzen und nach rechts fahren
    public static void backandRight(){
	
	Motor.A.setPower(7);
	Motor.C.setPower(7);
	Motor.A.backward();
	Motor.C.backward();
	try{ Thread.sleep(700);}catch (InterruptedException e){};

	Motor.A.stop();
	Motor.C.forward();
	try{ Thread.sleep(250);}catch (InterruptedException e){};
 //beschreibt letzten Zustand des Roboters
    public static int lastStatement=3;
        Motor.C.setPower(7);
	Motor.A.setPower(1);
	Motor.A.forward();
	Motor.C.forward();
 	MyTimer3.start();
    }

    //zurcksetzen und nach links
    public static void backandLeft(){

	Motor.A.setPower(7);
	Motor.C.setPower(7);
	Motor.A.backward();
	Motor.C.backward();
	try{ Thread.sleep(700);}catch (InterruptedException e){};

	Motor.C.stop();
	Motor.A.forward();
	try{ Thread.sleep(250);}catch (InterruptedException e){};


	Motor.A.setPower(7);
	Motor.C.setPower(1);
	Motor.A.forward();
	Motor.C.forward();
 	MyTimer3.start();
    }

    //rechts rumschieben
    public static void rightCorrect(){
	
        correct=2;
        ignoreSensorListener=true;
	time=0;
	MyTimer1.stop();
	MyTimer2.stop();
	activeTimer=false;
	Start.MyTimer4.start();
	cnt=0;
        
	Motor.A.setPower(7);
	Motor.C.setPower(7);
	Motor.A.stop();
	Motor.C.backward();
	try{ Thread.sleep(110);}catch (InterruptedException e){};

	Motor.A.forward();
	Motor.C.setPower(5);
	Motor.C.forward();

	ignoreSensorListener=false;
    }
    
     //links rumschieben
    public static void leftCorrect(){
	
        correct=1;
        ignoreSensorListener=true;
	time=0;
	MyTimer1.stop();
	MyTimer2.stop();
	activeTimer=false;
	Start.MyTimer4.start();
	cnt=0;

	Motor.A.setPower(7);
	Motor.C.setPower(7);
	Motor.C.stop();
	Motor.A.backward();

        try{ Thread.sleep(110);}catch (InterruptedException e){};

	Motor.C.forward();
	Motor.A.setPower(5);
	Motor.A.forward();

	ignoreSensorListener=false;
    }
    
    //umdrehen
    public static void turnAround(){

        Motor.A.setPower(7);
	Motor.C.setPower(7);
	Motor.A.forward();
	Motor.C.flt();

        try{ Thread.sleep(1300);}catch (InterruptedException e){};

	Motor.C.stop();
	Motor.A.backward();

        try{ Thread.sleep(2050);}catch (InterruptedException e){};
	lastStatement=leftnoTouch;
	Start.status=Start.bringBack;

	Motor.A.setPower(7);
	Motor.C.setPower(7);
	Motor.A.forward();
	Motor.C.forward();
	MyTimer3.start();
    }

    //bertrgt ein Packet
    public static void transfer(byte b){
        
        Serial.sendPacket(new byte[]{(byte)0xf7,b}, 0, 2);
    }

    //stellt eine Dose ab und dreht um
    public static void stopAll(){
        
        transfer((byte)123);
        Motor.A.setPower(7);
        Motor.C.setPower(7);
        Motor.A.backward();
        Motor.C.backward();
        try{ Thread.sleep(1200);}catch (InterruptedException e){};
	
	Motor.C.forward();
	Motor.A.flt();
        try{ Thread.sleep(1400);}catch (InterruptedException e){};

	Motor.A.stop();
	Motor.C.backward();
        try{ Thread.sleep(2050);}catch (InterruptedException e){};
	lastStatement=rightnoTouch;
	Start.status=Start.explore;

	Motor.A.setPower(7);
	Motor.C.setPower(7);
	Motor.A.forward();
	Motor.C.forward();
	MyTimer3.start();
    }
}

